Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision cddcc4a3904768c1032861a518e712bd08ea3156)
+++ boot/Makefile.common	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
@@ -166,4 +166,5 @@
 	$(USPACE_PATH)/app/loc/loc \
 	$(USPACE_PATH)/app/logview/logview \
+	$(USPACE_PATH)/app/logset/logset \
 	$(USPACE_PATH)/app/mkfat/mkfat \
 	$(USPACE_PATH)/app/mkexfat/mkexfat \
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision cddcc4a3904768c1032861a518e712bd08ea3156)
+++ uspace/Makefile	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
@@ -47,4 +47,5 @@
 	app/klog \
 	app/loc \
+	app/logset \
 	app/logview \
 	app/mkfat \
Index: uspace/app/logset/Makefile
===================================================================
--- uspace/app/logset/Makefile	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
+++ uspace/app/logset/Makefile	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
@@ -0,0 +1,35 @@
+#
+# Copyright (c) 2012 Vojtech Horky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+BINARY = logset
+
+SOURCES = \
+	main.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/logset/main.c
===================================================================
--- uspace/app/logset/main.c	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
+++ uspace/app/logset/main.c	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2012 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup logset
+ * @{
+ */
+/** @file Change logger behavior.
+ */
+#include <stdio.h>
+#include <async.h>
+#include <errno.h>
+#include <str_error.h>
+#include <io/logctl.h>
+
+int main(int argc, char *argv[])
+{
+	/* The only action is to set default logging level. */
+
+	if (argc < 2) {
+		fprintf(stderr, "Usage: %s <default-logging-level>\n", argv[0]);
+		return 1;
+	}
+
+	log_level_t new_default_level = (log_level_t) strtol(argv[1], NULL, 0);
+
+	int rc = logctl_set_default_level(new_default_level);
+
+	if (rc != EOK) {
+		fprintf(stderr, "Failed to change default logging level: %s.\n",
+		    str_error(rc));
+		return 2;
+	}
+
+	return 0;
+}
+
+/** @}
+ */
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision cddcc4a3904768c1032861a518e712bd08ea3156)
+++ uspace/lib/c/Makefile	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
@@ -97,4 +97,5 @@
 	generic/io/printf.c \
 	generic/io/log.c \
+	generic/io/logctl.c \
 	generic/io/klog.c \
 	generic/io/snprintf.c \
Index: uspace/lib/c/generic/io/logctl.c
===================================================================
--- uspace/lib/c/generic/io/logctl.c	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
+++ uspace/lib/c/generic/io/logctl.c	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
@@ -0,0 +1,76 @@
+/*
+ * Copyright (c) 2012 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+
+#include <assert.h>
+#include <unistd.h>
+#include <errno.h>
+#include <io/logctl.h>
+#include <ipc/logger.h>
+#include <ns.h>
+
+/** IPC session with the logger service. */
+static async_sess_t *logger_session = NULL;
+
+static int connect_to_logger()
+{
+	if (logger_session != NULL)
+		return EOK;
+
+	logger_session = service_connect_blocking(EXCHANGE_SERIALIZE,
+	    SERVICE_LOGGER, LOGGER_INTERFACE_CONTROL, 0);
+	if (logger_session == NULL)
+		return ENOMEM;
+
+	return EOK;
+}
+
+
+int logctl_set_default_level(log_level_t new_level)
+{
+	int rc = connect_to_logger();
+	if (rc != EOK)
+		return rc;
+
+	async_exch_t *exchange = async_exchange_begin(logger_session);
+	if (exchange == NULL)
+		return ENOMEM;
+
+	rc = (int) async_req_1_0(exchange,
+	    LOGGER_CTL_SET_DEFAULT_LEVEL, new_level);
+
+	async_exchange_end(exchange);
+
+	return rc;
+}
+
+/** @}
+ */
Index: uspace/lib/c/include/io/logctl.h
===================================================================
--- uspace/lib/c/include/io/logctl.h	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
+++ uspace/lib/c/include/io/logctl.h	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2011-2012 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+
+#ifndef LIBC_IO_LOGCTL_H_
+#define LIBC_IO_LOGCTL_H_
+
+#include <io/log.h>
+
+extern int logctl_set_default_level(log_level_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/ipc/logger.h
===================================================================
--- uspace/lib/c/include/ipc/logger.h	(revision cddcc4a3904768c1032861a518e712bd08ea3156)
+++ uspace/lib/c/include/ipc/logger.h	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
@@ -37,4 +37,9 @@
 
 typedef enum {
+	LOGGER_CTL_GET_DEFAULT_LEVEL = IPC_FIRST_USER_METHOD,
+	LOGGER_CTL_SET_DEFAULT_LEVEL
+} logger_control_request_t;
+
+typedef enum {
 	LOGGER_REGISTER = IPC_FIRST_USER_METHOD,
 	LOGGER_MESSAGE,
@@ -48,4 +53,6 @@
 
 typedef enum {
+	/** Interface for controlling logger behavior. */
+	LOGGER_INTERFACE_CONTROL,
 	/** Interface for servers writing to the log. */
 	LOGGER_INTERFACE_SINK,
Index: uspace/srv/logger/Makefile
===================================================================
--- uspace/srv/logger/Makefile	(revision cddcc4a3904768c1032861a518e712bd08ea3156)
+++ uspace/srv/logger/Makefile	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
@@ -32,4 +32,5 @@
 
 SOURCES = \
+	level.c \
 	main.c \
 	namespace.c
Index: uspace/srv/logger/logger.h
===================================================================
--- uspace/srv/logger/logger.h	(revision cddcc4a3904768c1032861a518e712bd08ea3156)
+++ uspace/srv/logger/logger.h	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
@@ -42,6 +42,4 @@
 #include <fibril_synch.h>
 
-#define DEFAULT_LOGGING_LEVEL LVL_NOTE
-
 #define NAME "logger"
 #define MAX_NAMESPACE_LENGTH 256
@@ -71,4 +69,7 @@
 log_message_t *namespace_get_next_message(logging_namespace_t *);
 
+log_level_t get_default_logging_level(void);
+int set_default_logging_level(log_level_t);
+
 #endif
 
Index: uspace/srv/logger/main.c
===================================================================
--- uspace/srv/logger/main.c	(revision cddcc4a3904768c1032861a518e712bd08ea3156)
+++ uspace/srv/logger/main.c	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
@@ -47,4 +47,34 @@
 #include "logger.h"
 
+static void connection_handler_control(void)
+{
+	printf(NAME "/control: new client.\n");
+
+	while (true) {
+		ipc_call_t call;
+		ipc_callid_t callid = async_get_call(&call);
+
+		if (!IPC_GET_IMETHOD(call))
+			break;
+
+		int rc;
+
+		switch (IPC_GET_IMETHOD(call)) {
+		case LOGGER_CTL_GET_DEFAULT_LEVEL:
+			async_answer_1(callid, EOK, get_default_logging_level());
+			break;
+		case LOGGER_CTL_SET_DEFAULT_LEVEL:
+			rc = set_default_logging_level(IPC_GET_ARG1(call));
+			async_answer_0(callid, rc);
+			break;
+		default:
+			async_answer_0(callid, EINVAL);
+			break;
+		}
+	}
+
+	printf(NAME "/control: client terminated.\n");
+}
+
 static logging_namespace_t *find_namespace_and_attach_writer(void)
 {
@@ -74,5 +104,5 @@
 static int handle_receive_message(logging_namespace_t *namespace, int level)
 {
-	bool skip_message = (level > DEFAULT_LOGGING_LEVEL) && !namespace_has_reader(namespace, level);
+	bool skip_message = (level > (int)get_default_logging_level()) && !namespace_has_reader(namespace, level);
 	if (skip_message) {
 		/* Abort the actual message buffer transfer. */
@@ -221,4 +251,8 @@
 
 	switch (iface) {
+	case LOGGER_INTERFACE_CONTROL:
+		async_answer_0(iid, EOK);
+		connection_handler_control();
+		break;
 	case LOGGER_INTERFACE_SINK:
 		/* First call has to be the registration. */
Index: uspace/srv/logger/namespace.c
===================================================================
--- uspace/srv/logger/namespace.c	(revision cddcc4a3904768c1032861a518e712bd08ea3156)
+++ uspace/srv/logger/namespace.c	(revision 669f5caed8b5063907bbb28370a6c9ceccd1455e)
@@ -126,5 +126,5 @@
 	}
 
-	namespace->logfile_level = DEFAULT_LOGGING_LEVEL;
+	namespace->logfile_level = get_default_logging_level();
 
 	fibril_mutex_initialize(&namespace->guard);
@@ -267,5 +267,5 @@
 void namespace_add_message(logging_namespace_t *namespace, const char *message, log_level_t level)
 {
-	if (level <= DEFAULT_LOGGING_LEVEL) {
+	if (level <= get_default_logging_level()) {
 		printf("[%s %d]: %s\n", namespace->name, level, message);
 	}