Index: uspace/drv/block/pc-floppy/pc-floppy.c
===================================================================
--- uspace/drv/block/pc-floppy/pc-floppy.c	(revision f77ede10a055275b0149015e2763f2fa6e718009)
+++ uspace/drv/block/pc-floppy/pc-floppy.c	(revision 705b65ea783e600c498820a02e8c656987dd4b29)
@@ -165,5 +165,5 @@
 	rc = pc_fdc_init_irq(fdc);
 	if (rc != EOK) {
-		ddf_msg(LVL_NOTE, "Init IRQ failed");
+		ddf_msg(LVL_ERROR, "Init IRQ failed");
 		return rc;
 	}
@@ -179,5 +179,5 @@
 	    AS_AREA_WRITE | AS_AREA_READ, 0, &fdc->dma_buf_pa, &buffer);
 	if (rc != EOK) {
-		ddf_msg(LVL_NOTE, "Failed allocating PRD table.");
+		ddf_msg(LVL_ERROR, "Failed allocating PRD table.");
 		goto error;
 	}
@@ -185,15 +185,15 @@
 	fdc->dma_buf = buffer;
 
-	ddf_msg(LVL_NOTE, "pc_fdc_ctrl_init: reset controller...");
+	ddf_msg(LVL_DEBUG, "pc_fdc_ctrl_init: reset controller...");
 	(void)pc_fdc_reset(fdc);
-	ddf_msg(LVL_NOTE, "pc_fdc_ctrl_init: read_ID..");
-
-	ddf_msg(LVL_NOTE, "pc_fdc_ctrl_init: MSR=0x%x",
+	ddf_msg(LVL_DEBUG, "pc_fdc_ctrl_init: read_ID..");
+
+	ddf_msg(LVL_DEBUG, "pc_fdc_ctrl_init: MSR=0x%x",
 	    pio_read_8(&fdc->regs->msr));
-	ddf_msg(LVL_NOTE, "pc_fdc_ctrl_init: DIR=0x%x",
+	ddf_msg(LVL_DEBUG, "pc_fdc_ctrl_init: DIR=0x%x",
 	    pio_read_8(&fdc->regs->dir));
-	ddf_msg(LVL_NOTE, "pc_fdc_ctrl_init: SRA=0x%x",
+	ddf_msg(LVL_DEBUG, "pc_fdc_ctrl_init: SRA=0x%x",
 	    pio_read_8(&fdc->regs->sra));
-	ddf_msg(LVL_NOTE, "pc_fdc_ctrl_init: SRB=0x%x",
+	ddf_msg(LVL_DEBUG, "pc_fdc_ctrl_init: SRB=0x%x",
 	    pio_read_8(&fdc->regs->srb));
 
@@ -213,9 +213,9 @@
 	/* Read ID MFM, D0, H0 */
 	rc = pc_fdc_read_id(fdc, true, 0, 0);
-	ddf_msg(LVL_NOTE, "pc_fdc_ctrl_init: read_ID -> %d", rc);
+	ddf_msg(LVL_DEBUG, "pc_fdc_ctrl_init: read_ID -> %d", rc);
 
 	rc = pc_fdc_drive_create(fdc, 0, &fdc->drive[0]);
 	if (rc != EOK) {
-		ddf_msg(LVL_NOTE, "pc_fdc_ctrl_init: pc_fdc_drive_create "
+		ddf_msg(LVL_ERROR, "pc_fdc_ctrl_init: pc_fdc_drive_create "
 		    "failed");
 		goto error;
@@ -454,4 +454,5 @@
 	bound = true;
 
+#if 0
 	rc = ddf_fun_add_to_category(fun, "partition");
 	if (rc != EOK) {
@@ -460,4 +461,5 @@
 		goto error;
 	}
+#endif
 
 	free(fun_name);
@@ -497,5 +499,5 @@
 
 	status = pio_read_8(&fdc->regs->msr);
-	ddf_msg(LVL_NOTE, "pc_fdc_send_byte: status=0x%x", status);
+	ddf_msg(LVL_DEBUG, "pc_fdc_send_byte: status=0x%x", status);
 	do {
 		cnt = msr_read_cycles;
@@ -513,8 +515,8 @@
 		stopwatch_stop(&sw);
 		nsec = stopwatch_get_nanos(&sw);
-		ddf_msg(LVL_NOTE, "nsec=%lld", nsec);
+		ddf_msg(LVL_DEBUG, "nsec=%lld", nsec);
 	} while (nsec < 1000 * msr_max_wait_usec);
 
-	ddf_msg(LVL_NOTE, "pc_fdc_send_byte: FAILED (status=0x%x)", status);
+	ddf_msg(LVL_ERROR, "pc_fdc_send_byte: FAILED (status=0x%x)", status);
 	return EIO;
 }
@@ -541,5 +543,5 @@
 
 	status = pio_read_8(&fdc->regs->msr);
-	ddf_msg(LVL_NOTE, "pc_fdc_send: final status=0x%x", status);
+	ddf_msg(LVL_DEBUG, "pc_fdc_send: final status=0x%x", status);
 	return EOK;
 }
@@ -567,5 +569,5 @@
 
 	status = pio_read_8(&fdc->regs->msr);
-	ddf_msg(LVL_NOTE, "pc_fdc_get_byte: status=0x%x", status);
+	ddf_msg(LVL_DEBUG, "pc_fdc_get_byte: status=0x%x", status);
 	do {
 		cnt = msr_read_cycles;
@@ -585,5 +587,5 @@
 	} while (nsec / 1000 < 1000 * msr_max_wait_usec);
 
-	ddf_msg(LVL_NOTE, "pc_fdc_get_byte: FAILED (status=0x%x)", status);
+	ddf_msg(LVL_ERROR, "pc_fdc_get_byte: FAILED (status=0x%x)", status);
 	return EIO;
 }
@@ -606,5 +608,5 @@
 		rc = pc_fdc_get_byte(fdc, &((uint8_t *)buf)[i]);
 		if (rc != EOK) {
-			ddf_msg(LVL_NOTE, "pc_fdc_get: abort after "
+			ddf_msg(LVL_ERROR, "pc_fdc_get: abort after "
 			    "reading %zu bytes", i);
 			return rc;
@@ -612,7 +614,7 @@
 	}
 
-	ddf_msg(LVL_NOTE, "pc_fdc_get: successfully read %zu bytes", i);
+	ddf_msg(LVL_DEBUG, "pc_fdc_get: successfully read %zu bytes", i);
 	status = pio_read_8(&fdc->regs->msr);
-	ddf_msg(LVL_NOTE, "pc_fdc_get: final status=0x%x", status);
+	ddf_msg(LVL_DEBUG, "pc_fdc_get: final status=0x%x", status);
 	return EOK;
 }
@@ -632,19 +634,19 @@
 	/* Clear DOR reset in case it was set (i.e., nreset := 1) */
 	dor = pio_read_8(&fdc->regs->dor);
-	ddf_msg(LVL_NOTE, "pc_fdc_reset: old DOR=0x%x, DOR := 0x%x", dor,
+	ddf_msg(LVL_DEBUG, "pc_fdc_reset: old DOR=0x%x, DOR := 0x%x", dor,
 	    dor & ~fdor_nreset);
 	pio_write_8(&fdc->regs->dor, dor & ~fdor_nreset);
 
 	dor = pio_read_8(&fdc->regs->dor);
-	ddf_msg(LVL_NOTE, "pc_fdc_reset: read DOR: value= 0x%x", dor);
+	ddf_msg(LVL_DEBUG, "pc_fdc_reset: read DOR: value= 0x%x", dor);
 
 	fibril_usleep(4);
 
-	ddf_msg(LVL_NOTE, "pc_fdc_reset: old DOR=0x%x, DOR := 0x%x", dor,
+	ddf_msg(LVL_DEBUG, "pc_fdc_reset: old DOR=0x%x, DOR := 0x%x", dor,
 	    dor | fdor_nreset | fdor_ndmagate);
 	pio_write_8(&fdc->regs->dor, dor | fdor_nreset | fdor_ndmagate);
 
 	dor = pio_read_8(&fdc->regs->dor);
-	ddf_msg(LVL_NOTE, "pc_fdc_reset: read DOR: value= 0x%x", dor);
+	ddf_msg(LVL_DEBUG, "pc_fdc_reset: read DOR: value= 0x%x", dor);
 
 	return EOK;
@@ -669,13 +671,13 @@
 
 	dor = pio_read_8(&fdc->regs->dor);
-	ddf_msg(LVL_NOTE, "pc_fdc_read_id: read DOR: value= 0x%x", dor);
+	ddf_msg(LVL_DEBUG, "pc_fdc_read_id: read DOR: value= 0x%x", dor);
 
 	dor |= fdor_me0; /* turn drive 0 motor on */
 	dor = (dor & ~0x03) | 0x00; /* select drive 0 */
 	pio_write_8(&fdc->regs->dor, dor);
-	ddf_msg(LVL_NOTE, "pc_fdc_read_id: DOR := 0x%x", dor);
+	ddf_msg(LVL_DEBUG, "pc_fdc_read_id: DOR := 0x%x", dor);
 
 	dor = pio_read_8(&fdc->regs->dor);
-	ddf_msg(LVL_NOTE, "pc_fdc_read_id: read DOR: value= 0x%x", dor);
+	ddf_msg(LVL_DEBUG, "pc_fdc_read_id: read DOR: value= 0x%x", dor);
 
 	/* 500 ms to let drive spin up */
@@ -685,5 +687,5 @@
 	cmd.hd_us = 0x00;
 
-	ddf_msg(LVL_NOTE, "read ID: send");
+	ddf_msg(LVL_DEBUG, "read ID: send");
 	rc = pc_fdc_send(fdc, &cmd, sizeof(cmd));
 	if (rc != EOK) {
@@ -692,5 +694,5 @@
 	}
 
-	ddf_msg(LVL_NOTE, "read ID: get");
+	ddf_msg(LVL_DEBUG, "read ID: get");
 	rc = pc_fdc_get(fdc, &status, sizeof(status));
 	if (rc != EOK) {
@@ -699,6 +701,6 @@
 	}
 
-	ddf_msg(LVL_NOTE, "read ID: DONE");
-	ddf_msg(LVL_NOTE, "st0=0x%x st1=0x%x st2=0x%x cyl=%u head=%u rec=%u "
+	ddf_msg(LVL_DEBUG, "read ID: DONE");
+	ddf_msg(LVL_DEBUG, "st0=0x%x st1=0x%x st2=0x%x cyl=%u head=%u rec=%u "
 	    "number=%u", status.st0, status.st1, status.st2,
 	    status.cyl, status.head, status.rec, status.number);
@@ -732,10 +734,10 @@
 	errno_t rc;
 
-	ddf_msg(LVL_NOTE, "pc_fdc_drive_read_data");
+	ddf_msg(LVL_DEBUG, "pc_fdc_drive_read_data");
 
 	memset(fdc->dma_buf, 0, fdc->dma_buf_size);
 
 	sess = ddf_dev_parent_sess_get(fdc->dev);
-	ddf_msg(LVL_NOTE, "hw_res_dma_channel_setup(sess=%p, chan=%d "
+	ddf_msg(LVL_DEBUG, "hw_res_dma_channel_setup(sess=%p, chan=%d "
 	    "pa=%lu size=%zu", sess, fdc->dma, fdc->dma_buf_pa,
 	    fdc->dma_buf_size);
@@ -743,5 +745,5 @@
 	    fdc->dma_buf_size, DMA_MODE_READ | DMA_MODE_AUTO |
 	    DMA_MODE_ON_DEMAND);
-	ddf_msg(LVL_NOTE, "hw_res_dma_channel_setup->%d", rc);
+	ddf_msg(LVL_DEBUG, "hw_res_dma_channel_setup->%d", rc);
 
 	cmd.flags_cc = fcf_mf | fcc_read_data;
@@ -755,5 +757,5 @@
 	cmd.dtl = 0xff;
 
-	ddf_msg(LVL_NOTE, "read data: send");
+	ddf_msg(LVL_DEBUG, "read data: send");
 	rc = pc_fdc_send(fdc, &cmd, sizeof(cmd));
 	if (rc != EOK) {
@@ -762,5 +764,5 @@
 	}
 
-	ddf_msg(LVL_NOTE, "read data: get");
+	ddf_msg(LVL_DEBUG, "read data: get");
 	rc = pc_fdc_get(fdc, &status, sizeof(status));
 	if (rc != EOK) {
@@ -769,6 +771,6 @@
 	}
 
-	ddf_msg(LVL_NOTE, "read data: DONE");
-	ddf_msg(LVL_NOTE, "st0=0x%x st1=0x%x st2=0x%x cyl=%u head=%u rec=%u "
+	ddf_msg(LVL_DEBUG, "read data: DONE");
+	ddf_msg(LVL_DEBUG, "st0=0x%x st1=0x%x st2=0x%x cyl=%u head=%u rec=%u "
 	    "number=%u", status.st0, status.st1, status.st2,
 	    status.cyl, status.head, status.rec, status.number);
@@ -806,5 +808,5 @@
 	errno_t rc;
 
-	ddf_msg(LVL_NOTE, "pc_fdc_drive_write_data");
+	ddf_msg(LVL_DEBUG, "pc_fdc_drive_write_data");
 
 	/* Copy data from source buffer to DMA buffer */
@@ -813,5 +815,5 @@
 
 	sess = ddf_dev_parent_sess_get(fdc->dev);
-	ddf_msg(LVL_NOTE, "hw_res_dma_channel_setup(sess=%p, chan=%d "
+	ddf_msg(LVL_DEBUG, "hw_res_dma_channel_setup(sess=%p, chan=%d "
 	    "pa=%lu size=%zu", sess, fdc->dma, fdc->dma_buf_pa,
 	    fdc->dma_buf_size);
@@ -819,5 +821,5 @@
 	    fdc->dma_buf_size, DMA_MODE_WRITE | DMA_MODE_AUTO |
 	    DMA_MODE_ON_DEMAND);
-	ddf_msg(LVL_NOTE, "hw_res_dma_channel_setup->%d", rc);
+	ddf_msg(LVL_DEBUG, "hw_res_dma_channel_setup->%d", rc);
 
 	cmd.flags_cc = fcf_mf | fcc_write_data;
@@ -831,5 +833,5 @@
 	cmd.dtl = 0xff;
 
-	ddf_msg(LVL_NOTE, "write data: send");
+	ddf_msg(LVL_DEBUG, "write data: send");
 	rc = pc_fdc_send(fdc, &cmd, sizeof(cmd));
 	if (rc != EOK) {
@@ -838,5 +840,5 @@
 	}
 
-	ddf_msg(LVL_NOTE, "write data: get");
+	ddf_msg(LVL_DEBUG, "write data: get");
 	rc = pc_fdc_get(fdc, &status, sizeof(status));
 	if (rc != EOK) {
@@ -845,6 +847,6 @@
 	}
 
-	ddf_msg(LVL_NOTE, "write data: DONE");
-	ddf_msg(LVL_NOTE, "st0=0x%x st1=0x%x st2=0x%x cyl=%u head=%u rec=%u "
+	ddf_msg(LVL_DEBUG, "write data: DONE");
+	ddf_msg(LVL_DEBUG, "st0=0x%x st1=0x%x st2=0x%x cyl=%u head=%u rec=%u "
 	    "number=%u", status.st0, status.st1, status.st2,
 	    status.cyl, status.head, status.rec, status.number);
@@ -874,5 +876,5 @@
 	cmd.cc = fcc_sense_int_sts;
 
-	ddf_msg(LVL_NOTE, "Sense Interrupt Status: send");
+	ddf_msg(LVL_DEBUG, "Sense Interrupt Status: send");
 	rc = pc_fdc_send(fdc, &cmd, sizeof(cmd));
 	if (rc != EOK) {
@@ -882,5 +884,5 @@
 	}
 
-	ddf_msg(LVL_NOTE, "Sense Interrupt Status: get");
+	ddf_msg(LVL_DEBUG, "Sense Interrupt Status: get");
 	rc = pc_fdc_get(fdc, &status, sizeof(status));
 	if (rc != EOK) {
@@ -890,6 +892,6 @@
 	}
 
-	ddf_msg(LVL_NOTE, "Sense Interrupt Status: DONE");
-	ddf_msg(LVL_NOTE, "st0=0x%x pcn=0x%x", status.st0, status.pcn);
+	ddf_msg(LVL_DEBUG, "Sense Interrupt Status: DONE");
+	ddf_msg(LVL_DEBUG, "st0=0x%x pcn=0x%x", status.st0, status.pcn);
 
 	return EOK;
@@ -916,5 +918,5 @@
 	h = ipc_get_arg5(call);
 	n = ipc_get_imethod(call);
-	ddf_msg(LVL_NOTE, "pc_fdc_irq_handler st0=%x st1=%x st2=%x c=%u h=%u n=%u",
+	ddf_msg(LVL_DEBUG, "pc_fdc_irq_handler st0=%x st1=%x st2=%x c=%u h=%u n=%u",
 	    st0, st1, st2, c, h, n);
 
@@ -990,5 +992,5 @@
 	errno_t rc;
 
-	ddf_msg(LVL_NOTE, "pc_fdc_bd_read_blocks");
+	ddf_msg(LVL_DEBUG, "pc_fdc_bd_read_blocks");
 
 	if (size < cnt * drive->sec_size) {
@@ -1013,5 +1015,5 @@
 	return EOK;
 error:
-	ddf_msg(LVL_NOTE, "pc_fdc_bd_read_blocks: rc=%d", rc);
+	ddf_msg(LVL_ERROR, "pc_fdc_bd_read_blocks: rc=%d", rc);
 	return rc;
 }
@@ -1048,5 +1050,5 @@
 	errno_t rc;
 
-	ddf_msg(LVL_NOTE, "pc_fdc_bd_write_blocks");
+	ddf_msg(LVL_DEBUG, "pc_fdc_bd_write_blocks");
 
 	if (size < cnt * drive->sec_size) {
@@ -1071,5 +1073,5 @@
 	return EOK;
 error:
-	ddf_msg(LVL_NOTE, "pc_fdc_bd_write_blocks: rc=%d", rc);
+	ddf_msg(LVL_ERROR, "pc_fdc_bd_write_blocks: rc=%d", rc);
 	return rc;
 }